| Flutter Impeller |

Public Member Functions | Protected Types | Protected Member Functions | Static Protected Member Functions | List of all members
impeller::ColorSourceContents Class Reference

`#include <color_source_contents.h>`

Inheritance diagram for impeller::ColorSourceContents:

## Public Member Functions
| ColorSourceContents ()
| ~ColorSourceContents () override
void | SetGeometry (std::shared_ptr< Geometry > geometry)
| Set the geometry that this contents will use to render. More...
const std::shared_ptr< Geometry > & | GetGeometry () const
| Get the geometry that this contents will use to render. More...
void | SetEffectTransform (Matrix matrix)
| Set the effect transform for this color source. More...
const Matrix & | GetInverseEffectTransform () const
| Set the inverted effect transform for this color source. More...
void | SetOpacityFactor (Scalar opacity)
| Set the opacity factor for this color source. More...
Scalar | GetOpacityFactor () const
| Get the opacity factor for this color source. More...
virtual bool | IsSolidColor () const
std::optional< Rect > | GetCoverage (const Entity &entity) const override
| Get the area of the render pass that will be affected when this contents is rendered. More...
bool | CanInheritOpacity (const Entity &entity) const override
| Whether or not this contents can accept the opacity peephole optimization. More...
void | SetInheritedOpacity (Scalar opacity) override
| Inherit the provided opacity. More...
Public Member Functions inherited from impeller::Contents
| Contents ()
virtual | ~Contents ()
virtual void | PopulateGlyphAtlas (const std::shared_ptr< LazyGlyphAtlas > &lazy_glyph_atlas, Scalar scale)
| Add any text data to the specified lazy atlas. The scale parameter must be used again later when drawing the text. More...
virtual bool | Render (const ContentContext &renderer, const Entity &entity, RenderPass &pass) const =0
void | SetCoverageHint (std::optional< Rect > coverage_hint)
| Hint that specifies the coverage area of this Contents that will actually be used during rendering. This is for optimization purposes only and can not be relied on as a clip. May optionally affect the result of `GetCoverage()`. More...
const std::optional< Rect > & | GetCoverageHint () const
virtual bool | IsOpaque () const
| Whether this Contents only emits opaque source colors from the fragment stage. This value does not account for any entity properties (e.g. the blend mode), clips/visibility culling, or inherited opacity. More...
virtual ClipCoverage | GetClipCoverage (const Entity &entity, const std::optional< Rect > &current_clip_coverage) const
| Given the current pass space bounding rectangle of the clip buffer, return the expected clip coverage after this draw call. This should only be implemented for contents that may write to the clip buffer. More...
virtual std::optional< Snapshot > | RenderToSnapshot (const ContentContext &renderer, const Entity &entity, std::optional< Rect > coverage_limit=std::nullopt, const std::optional< SamplerDescriptor > &sampler_descriptor=std::nullopt, bool msaa_enabled=true, int32_t mip_count=1, const std::string &label="Snapshot") const
| Render this contents to a snapshot, respecting the entity's transform, path, clip depth, and blend mode. The result texture size is always the size of `GetCoverage(entity)`. More...
virtual bool | ShouldRender (const Entity &entity, const std::optional< Rect > clip_coverage) const
std::optional< Size > | GetColorSourceSize () const
| Return the color source's intrinsic size, if available. More...
void | SetColorSourceSize (Size size)
virtual std::optional< Color > | AsBackgroundColor (const Entity &entity, ISize target_size) const
| Returns a color if this Contents will flood the given `target_size` with a color. This output color is the "Source" color that will be used for the Entity's blend operation. More...
virtual const FilterContents * | AsFilter () const
| Cast to a filter. Returns `nullptr` if this Contents is not a filter. More...
virtual bool | ApplyColorFilter (const ColorFilterProc &color_filter_proc)
| If possible, applies a color filter to this contents inputs on the CPU. More...

## Protected Types
using | BindFragmentCallback = std::function< bool(RenderPass &pass)>
using | PipelineBuilderMethod = std::shared_ptr< Pipeline< PipelineDescriptor > >(impeller::ContentContext::*)(ContentContextOptions) const
using | PipelineBuilderCallback = std::function< std::shared_ptr< Pipeline< PipelineDescriptor > >(ContentContextOptions)>
using | CreateGeometryCallback = std::function< GeometryResult(const ContentContext &renderer, const Entity &entity, RenderPass &pass, const Geometry &geom)>

## Protected Member Functions
template<typename VertexShaderT >
bool | DrawGeometry (const ContentContext &renderer, const Entity &entity, RenderPass &pass, const PipelineBuilderCallback &pipeline_callback, typename VertexShaderT::FrameInfo frame_info, const BindFragmentCallback &bind_fragment_callback, bool force_stencil=false, const CreateGeometryCallback &create_geom_callback=DefaultCreateGeometryCallback) const

## Static Protected Member Functions
static GeometryResult | DefaultCreateGeometryCallback (const ContentContext &renderer, const Entity &entity, RenderPass &pass, const Geometry &geom)

## Additional Inherited Members
Public Types inherited from impeller::Contents
using | ColorFilterProc = std::function< Color(Color)>
using | RenderProc = std::function< bool(const ContentContext &renderer, const Entity &entity, RenderPass &pass)>
using | CoverageProc = std::function< std::optional< Rect >(const Entity &entity)>
Static Public Member Functions inherited from impeller::Contents
static std::shared_ptr< Contents > | MakeAnonymous (RenderProc render_proc, CoverageProc coverage_proc)

## Detailed Description

Color sources are geometry-ignostic `Contents` capable of shading any area defined by an `impeller::Geometry`. Conceptually, `impeller::ColorSourceContents` implement a particular color shading behavior.

This separation of concerns between geometry and color source output allows Impeller to handle most possible draw combinations in a consistent way. For example: There are color sources for handling solid colors, gradients, textures, custom runtime effects, and even 3D scenes.

There are some special rendering exceptions that deviate from this pattern and cross geometry and color source concerns, such as text atlas and image atlas rendering. Special `Contents` exist for rendering these behaviors which don't implement `ColorSourceContents`.

See also
  `impeller::Geometry`

Definition at line 37 of file color_source_contents.h.

## Member Typedef Documentation

## ◆ BindFragmentCallback

using impeller::ColorSourceContents::BindFragmentCallback = std::function<bool(RenderPass& pass)>
| protected

Definition at line 109 of file color_source_contents.h.

## ◆ CreateGeometryCallback

using impeller::ColorSourceContents::CreateGeometryCallback = std::function<GeometryResult(const ContentContext& renderer, const Entity& entity, RenderPass& pass, const Geometry& geom)>
| protected

Definition at line 119 of file color_source_contents.h.

## ◆ PipelineBuilderCallback

using impeller::ColorSourceContents::PipelineBuilderCallback = std::function<std::shared_ptr<Pipeline<PipelineDescriptor> >( ContentContextOptions)>
| protected

Definition at line 114 of file color_source_contents.h.

## ◆ PipelineBuilderMethod

using impeller::ColorSourceContents::PipelineBuilderMethod = std::shared_ptr<Pipeline<PipelineDescriptor> > ( impeller::ContentContext::*)(ContentContextOptions) const
| protected

Definition at line 111 of file color_source_contents.h.

## Constructor & Destructor Documentation

## ◆ ColorSourceContents()

impeller::ColorSourceContents::ColorSourceContents | ( |  | ) |
| default

## ◆ ~ColorSourceContents()

impeller::ColorSourceContents::~ColorSourceContents | ( |  | ) |
| override default

## Member Function Documentation

## ◆ CanInheritOpacity()

bool impeller::ColorSourceContents::CanInheritOpacity | ( | const Entity & | entity | ) | const
| override virtual

Whether or not this contents can accept the opacity peephole optimization.

By default all contents return false. Contents are responsible for determining whether or not their own geometries intersect in a way that makes accepting opacity impossible. It is always safe to return false, especially if computing overlap would be computationally expensive.

Reimplemented from impeller::Contents.

Reimplemented in impeller::RuntimeEffectContents.

Definition at line 49 of file color_source_contents.cc.

49 {
50 return true;
51 }

## ◆ DefaultCreateGeometryCallback()

static GeometryResult impeller::ColorSourceContents::DefaultCreateGeometryCallback | ( | const ContentContext & | renderer,
|  | const Entity & | entity,
|  | RenderPass & | pass,
|  | const Geometry & | geom
| ) |  |
| inline static protected

Definition at line 121 of file color_source_contents.h.

125 {
126 return geom.GetPositionBuffer(renderer, entity, pass);
127 }

References impeller::Geometry::GetPositionBuffer().

## ◆ DrawGeometry()

template<typename VertexShaderT >

bool impeller::ColorSourceContents::DrawGeometry | ( | const ContentContext & | renderer,
|  | const Entity & | entity,
|  | RenderPass & | pass,
|  | const PipelineBuilderCallback & | pipeline_callback,
|  | typename VertexShaderT::FrameInfo | frame_info,
|  | const BindFragmentCallback & | bind_fragment_callback,
|  | bool | force_stencil = `false`,
|  | const CreateGeometryCallback & | create_geom_callback = `DefaultCreateGeometryCallback`
| ) |  | const
| inline protected

Stencil preparation draw.

Cover draw.

Definition at line 130 of file color_source_contents.h.

138 {
139 auto options = OptionsFromPassAndEntity(pass, entity);
140
141 GeometryResult::Mode geometry_mode = GetGeometry()->GetResultMode();
142 Geometry& geometry = *GetGeometry();
143
144 bool is_stencil_then_cover =
145 geometry_mode == GeometryResult::Mode::kNonZero ||
146 geometry_mode == GeometryResult::Mode::kEvenOdd;
147 if (!is_stencil_then_cover && force_stencil) {
148 geometry_mode = GeometryResult::Mode::kNonZero;
149 is_stencil_then_cover = true;
150 }
151
152 if (is_stencil_then_cover) {
153 pass.SetStencilReference(0);
154
155 /// Stencil preparation draw.
156
157 GeometryResult stencil_geometry_result =
158 GetGeometry()->GetPositionBuffer(renderer, entity, pass);
159 if (stencil_geometry_result.vertex_buffer.vertex_count == 0u) {
160 return true;
161 }
162 pass.SetVertexBuffer(std::move(stencil_geometry_result.vertex_buffer));
163 options.primitive_type = stencil_geometry_result.type;
164
165 options.blend_mode = BlendMode::kDestination;
166 switch (stencil_geometry_result.mode) {
167 case GeometryResult::Mode::kNonZero:
168 pass.SetCommandLabel("Stencil preparation (NonZero)");
169 options.stencil_mode =
170 ContentContextOptions::StencilMode::kStencilNonZeroFill;
171 break;
172 case GeometryResult::Mode::kEvenOdd:
173 pass.SetCommandLabel("Stencil preparation (EvenOdd)");
174 options.stencil_mode =
175 ContentContextOptions::StencilMode::kStencilEvenOddFill;
176 break;
177 default:
178 if (force_stencil) {
179 pass.SetCommandLabel("Stencil preparation (NonZero)");
180 options.stencil_mode =
181 ContentContextOptions::StencilMode::kStencilNonZeroFill;
182 break;
183 }
184 FML_UNREACHABLE();
185 }
186 pass.SetPipeline(renderer.GetClipPipeline(options));
187 ClipPipeline::VertexShader::FrameInfo clip_frame_info;
188 clip_frame_info.depth = entity.GetShaderClipDepth();
189 clip_frame_info.mvp = stencil_geometry_result.transform;
190 ClipPipeline::VertexShader::BindFrameInfo(
191 pass, renderer.GetTransientsBuffer().EmplaceUniform(clip_frame_info));
192
193 if (!pass.Draw().ok()) {
194 return false;
195 }
196
197 /// Cover draw.
198
199 options.blend_mode = entity.GetBlendMode();
200 options.stencil_mode = ContentContextOptions::StencilMode::kCoverCompare;
201 std::optional<Rect> maybe_cover_area = GetGeometry()->GetCoverage({});
202 if (!maybe_cover_area.has_value()) {
203 return true;
204 }
205 geometry = RectGeometry(maybe_cover_area.value());
206 }
207
208 GeometryResult geometry_result =
209 create_geom_callback(renderer, entity, pass, geometry);
210 if (geometry_result.vertex_buffer.vertex_count == 0u) {
211 return true;
212 }
213 pass.SetVertexBuffer(std::move(geometry_result.vertex_buffer));
214 options.primitive_type = geometry_result.type;
215
216 // Take the pre-populated vertex shader uniform struct and set managed
217 // values.
218 frame_info.mvp = geometry_result.transform;
219
220 // If overdraw prevention is enabled (like when drawing stroke paths), we
221 // increment the stencil buffer as we draw, preventing overlapping fragments
222 // from drawing. Afterwards, we need to append another draw call to clean up
223 // the stencil buffer (happens below in this method).
224 if (geometry_result.mode == GeometryResult::Mode::kPreventOverdraw) {
225 options.stencil_mode =
226 ContentContextOptions::StencilMode::kOverdrawPreventionIncrement;
227 }
228 pass.SetStencilReference(0);
229
230 VertexShaderT::BindFrameInfo(
231 pass, renderer.GetTransientsBuffer().EmplaceUniform(frame_info));
232
233 // The reason we need to have a callback mechanism here is that this routine
234 // may insert draw calls before the main draw call below. For example, for
235 // sufficiently complex paths we may opt to use stencil-then-cover to avoid
236 // tessellation.
237 if (!bind_fragment_callback(pass)) {
238 return false;
239 }
240
241 pass.SetPipeline(pipeline_callback(options));
242
243 if (!pass.Draw().ok()) {
244 return false;
245 }
246
247 // If we performed overdraw prevention, a subsection of the clip heightmap
248 // was incremented by 1 in order to self-clip. So simply append a clip
249 // restore to clean it up.
250 if (geometry_result.mode == GeometryResult::Mode::kPreventOverdraw) {
251 auto restore = ClipRestoreContents();
252 restore.SetRestoreCoverage(GetCoverage(entity));
253 Entity restore_entity = entity.Clone();
254 return restore.Render(renderer, restore_entity, pass);
255 }
256 return true;
257 }

References impeller::Entity::Clone(), impeller::RenderPass::Draw(), impeller::HostBuffer::EmplaceUniform(), impeller::Entity::GetBlendMode(), impeller::ContentContext::GetClipPipeline(), GetCoverage(), GetGeometry(), impeller::Entity::GetShaderClipDepth(), impeller::ContentContext::GetTransientsBuffer(), impeller::ContentContextOptions::kCoverCompare, impeller::kDestination, impeller::GeometryResult::kEvenOdd, impeller::GeometryResult::kNonZero, impeller::ContentContextOptions::kOverdrawPreventionIncrement, impeller::GeometryResult::kPreventOverdraw, impeller::ContentContextOptions::kStencilEvenOddFill, impeller::ContentContextOptions::kStencilNonZeroFill, impeller::GeometryResult::mode, impeller::OptionsFromPassAndEntity(), impeller::Entity::Render(), impeller::RenderPass::SetCommandLabel(), impeller::RenderPass::SetPipeline(), impeller::RenderPass::SetStencilReference(), impeller::RenderPass::SetVertexBuffer(), impeller::GeometryResult::transform, impeller::GeometryResult::type, impeller::GeometryResult::vertex_buffer, and impeller::VertexBuffer::vertex_count.

## ◆ GetCoverage()

std::optional< Rect > impeller::ColorSourceContents::GetCoverage | ( | const Entity & | entity | ) | const
| override virtual

Get the area of the render pass that will be affected when this contents is rendered.

During rendering, coverage coordinates count pixels from the top left corner of the framebuffer.

Returns
  The coverage rectangle. An `std::nullopt` result means that rendering this contents has no effect on the output color.

Implements impeller::Contents.

Reimplemented in impeller::SolidColorContents.

Definition at line 44 of file color_source_contents.cc.

45 {
46 return geometry_->GetCoverage(entity.GetTransform());
47 };

References impeller::Entity::GetTransform().

Referenced by DrawGeometry(), impeller::SceneContents::Render(), and impeller::TiledTextureContents::RenderToSnapshot().

## ◆ GetGeometry()

const std::shared_ptr< Geometry > & impeller::ColorSourceContents::GetGeometry | ( |  | ) | const

Get the geometry that this contents will use to render.

Definition at line 20 of file color_source_contents.cc.

20 {
21 return geometry_;
22 }

Referenced by impeller::SolidColorContents::AsBackgroundColor(), DrawGeometry(), impeller::SolidColorContents::GetCoverage(), impeller::SceneContents::Render(), impeller::TiledTextureContents::Render(), impeller::SolidColorContents::Render(), and impeller::TiledTextureContents::RenderToSnapshot().

## ◆ GetInverseEffectTransform()

const Matrix & impeller::ColorSourceContents::GetInverseEffectTransform | ( |  | ) | const

Set the inverted effect transform for this color source.

         When the effect transform is set via `SetEffectTransform`, the
         value is inverted upon storage. The reason for this is that most
         color sources internally use the inverted transform.

Returns
  The inverse of the transform set by `SetEffectTransform`.

See also
  `SetEffectTransform`

Definition at line 36 of file color_source_contents.cc.

36 {
37 return inverse_matrix_;
38 }

Referenced by impeller::TiledTextureContents::Render(), and impeller::TiledTextureContents::RenderToSnapshot().

## ◆ GetOpacityFactor()

Scalar impeller::ColorSourceContents::GetOpacityFactor | ( |  | ) | const

Get the opacity factor for this color source.

        This value is is factored into the output of the color source in
        addition to opacity information that may be supplied any other
        inputs.

Note
  If set, the output of this method factors factors in the inherited opacity of this `Contents`.

See also
  `Contents::CanInheritOpacity`

Definition at line 28 of file color_source_contents.cc.

28 {
29 return opacity_ * inherited_opacity_;
30 }

Referenced by impeller::SolidColorContents::GetColor(), impeller::RadialGradientContents::IsOpaque(), impeller::LinearGradientContents::IsOpaque(), impeller::SweepGradientContents::IsOpaque(), impeller::TiledTextureContents::IsOpaque(), impeller::TiledTextureContents::Render(), and impeller::TiledTextureContents::RenderToSnapshot().

## ◆ IsSolidColor()

bool impeller::ColorSourceContents::IsSolidColor | ( |  | ) | const
| virtual

Reimplemented in impeller::SolidColorContents.

Definition at line 40 of file color_source_contents.cc.

40 {
41 return false;
42 }

## ◆ SetEffectTransform()

void impeller::ColorSourceContents::SetEffectTransform | ( | Matrix | matrix | ) |

Set the effect transform for this color source.

        The effect transform is a transform matrix that is applied to
        the shaded color output and does not impact geometry in any way.

        For example: With repeat tiling, any gradient or
        `TiledTextureContents` could be used with an effect transform to
        inexpensively draw an infinite scrolling background pattern.

Definition at line 32 of file color_source_contents.cc.

32 {
33 inverse_matrix_ = matrix.Invert();
34 }

References impeller::Matrix::Invert().

Referenced by impeller::SceneContents::Render().

## ◆ SetGeometry()

void impeller::ColorSourceContents::SetGeometry | ( | std::shared_ptr< Geometry > | geometry | ) |

Set the geometry that this contents will use to render.

Definition at line 16 of file color_source_contents.cc.

16 {
17 geometry_ = std::move(geometry);
18 }

Referenced by impeller::SceneContents::Render(), and impeller::testing::TEST_P().

## ◆ SetInheritedOpacity()

void impeller::ColorSourceContents::SetInheritedOpacity | ( | Scalar | opacity | ) |
| override virtual

Inherit the provided opacity.

       Use of this method is invalid if CanAcceptOpacity returns false.

Reimplemented from impeller::Contents.

Definition at line 53 of file color_source_contents.cc.

53 {
54 inherited_opacity_ = opacity;
55 }

## ◆ SetOpacityFactor()

void impeller::ColorSourceContents::SetOpacityFactor | ( | Scalar | opacity | ) |

Set the opacity factor for this color source.

Definition at line 24 of file color_source_contents.cc.

24 {
25 opacity_ = alpha;
26 }

The documentation for this class was generated from the following files:

- impeller/entity/contents/color_source_contents.h
- impeller/entity/contents/color_source_contents.cc

impeller::ContentContextOptions::StencilMode::kOverdrawPreventionIncrement
@ kOverdrawPreventionIncrement
impeller::BlendMode::kDestination
@ kDestination
impeller::ColorSourceContents::GetGeometry
const std::shared_ptr< Geometry > & GetGeometry() const
Get the geometry that this contents will use to render.
Definition: color_source_contents.cc:20
impeller::ContentContextOptions::StencilMode::kStencilEvenOddFill
@ kStencilEvenOddFill
impeller::GeometryResult::Mode::kEvenOdd
@ kEvenOdd
impeller::GeometryResult::Mode
Mode
Definition: geometry.h:20
impeller::OptionsFromPassAndEntity
ContentContextOptions OptionsFromPassAndEntity(const RenderPass &pass, const Entity &entity)
Definition: contents.cc:34
impeller::ContentContextOptions::StencilMode::kStencilNonZeroFill
@ kStencilNonZeroFill
impeller::Matrix::Invert
Matrix Invert() const
Definition: matrix.cc:97
impeller::ColorSourceContents::GetCoverage
std::optional< Rect > GetCoverage(const Entity &entity) const override
Get the area of the render pass that will be affected when this contents is rendered.
Definition: color_source_contents.cc:44
impeller::GeometryResult::Mode::kPreventOverdraw
@ kPreventOverdraw
impeller::ContentContextOptions::StencilMode::kCoverCompare
@ kCoverCompare
impeller::GeometryResult::Mode::kNonZero
@ kNonZero